    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * DefaultKeyedValue.java
    029     * ----------------------
    030     * (C) Copyright 2002-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 31-Oct-2002 : Version 1 (DG);
    038     * 13-Mar-2003 : Added equals() method, and implemented Serializable (DG);
    039     * 18-Aug-2003 : Implemented Cloneable (DG);
    040     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.base (DG);
    041     * 15-Sep-2004 : Added PublicCloneable interface (DG);
    042     * ------------- JFREECHART 1.0.x ---------------------------------------------
    043     * 11-Jun-2007 : Added toString() method to help with debugging (DG);
    044     * 15-Feb-2008 : Prevent null key (DG);
    045     * 07-Apr-2008 : Removed to-do item (DG);
    046     *
    047     */
    048
    049    package org.jfree.data;
    050
    051    import java.io.Serializable;
    052
    053    import org.jfree.util.PublicCloneable;
    054
    055    /**
    056     * A (key, value) pair.  This class provides a default implementation
    057     * of the {@link KeyedValue} interface.
    058     */
    059    public class DefaultKeyedValue implements KeyedValue, Cloneable,
    060            PublicCloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -7388924517460437712L;
    064
    065        /** The key. */
    066        private Comparable key;
    067
    068        /** The value. */
    069        private Number value;
    070
    071        /**
    072         * Creates a new (key, value) item.
    073         *
    074         * @param key  the key (should be immutable, <code>null</code> not
    075         *         permitted).
    076         * @param value  the value (<code>null</code> permitted).
    077         */
    078        public DefaultKeyedValue(Comparable key, Number value) {
    079            if (key == null) {
    080                throw new IllegalArgumentException("Null 'key' argument.");
    081            }
    082            this.key = key;
    083            this.value = value;
    084        }
    085
    086        /**
    087         * Returns the key.
    088         *
    089         * @return The key (never <code>null</code>).
    090         */
    091        public Comparable getKey() {
    092            return this.key;
    093        }
    094
    095        /**
    096         * Returns the value.
    097         *
    098         * @return The value (possibly <code>null</code>).
    099         */
    100        public Number getValue() {
    101            return this.value;
    102        }
    103
    104        /**
    105         * Sets the value.
    106         *
    107         * @param value  the value (<code>null</code> permitted).
    108         */
    109        public synchronized void setValue(Number value) {
    110            this.value = value;
    111        }
    112
    113        /**
    114         * Tests this key-value pair for equality with an arbitrary object.
    115         *
    116         * @param obj  the object (<code>null</code> permitted).
    117         *
    118         * @return A boolean.
    119         */
    120        public boolean equals(Object obj) {
    121            if (obj == this) {
    122                return true;
    123            }
    124            if (!(obj instanceof DefaultKeyedValue)) {
    125                return false;
    126            }
    127            DefaultKeyedValue that = (DefaultKeyedValue) obj;
    128
    129            if (!this.key.equals(that.key)) {
    130                return false;
    131            }
    132            if (this.value != null
    133                    ? !this.value.equals(that.value) : that.value != null) {
    134                return false;
    135            }
    136            return true;
    137        }
    138
    139        /**
    140         * Returns a hash code.
    141         *
    142         * @return A hash code.
    143         */
    144        public int hashCode() {
    145            int result;
    146            result = (this.key != null ? this.key.hashCode() : 0);
    147            result = 29 * result + (this.value != null ? this.value.hashCode() : 0);
    148            return result;
    149        }
    150
    151        /**
    152         * Returns a clone.  It is assumed that both the key and value are
    153         * immutable objects, so only the references are cloned, not the objects
    154         * themselves.
    155         *
    156         * @return A clone.
    157         *
    158         * @throws CloneNotSupportedException Not thrown by this class, but
    159         *         subclasses (if any) might.
    160         */
    161        public Object clone() throws CloneNotSupportedException {
    162            DefaultKeyedValue clone = (DefaultKeyedValue) super.clone();
    163            return clone;
    164        }
    165
    166        /**
    167         * Returns a string representing this instance, primarily useful for
    168         * debugging.
    169         *
    170         * @return A string.
    171         */
    172        public String toString() {
    173            return "(" + this.key.toString() + ", " + this.value.toString() + ")";
    174        }
    175
    176    }